/* 
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * File desktop.c : User interface for SimCoupe : Destop functions
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "z80.h"
#include "mem.h"
#include "sam.h"
#include "util.h"

#include "dialog.h"

/* Logo pixmap */
#include "logo.h"

static Pixmap *DefaultWallPaper = &LogoGlyph;

void
DesktopDraw(void)
{

    /* Set the background colour */
    SetBorder(USER_COL+4);
    SetDisplay(USER_COL+4);

    /* Draw the wallpaper */
    DesktopWallpaper(DefaultWallPaper, 69, 69);
}

void
DesktopWallpaper(Pixmap *TheWPPixmap, int RepeatX, int RepeatY)
{
    /* Draw the Wallpaper, repeating the pattern as required */
    
    int xpos = 0;
    int ypos = 0;

    while (xpos < DISPLAY_WIDTH) {
        ypos = 0;
        while (ypos < DISPLAY_HEIGHT) {

            DrawPixmap(xpos, ypos, TheWPPixmap, DM_OVER);

            ypos += RepeatY;
        }
        xpos += RepeatX;
    } 

}



