/* 
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * File form.c : User interface for SimCoupe : Exec Object functions
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "z80.h"
#include "mem.h"
#include "sam.h"
#include "util.h"

#include "dialog.h"

/* Exec component data structures */


/* Exec Object routines */

DialogObject *
ExecCreate(uns8 x, uns8 y, uns8 width, uns8 height, DialogObject *TheParent)
{
	/* Create an Exec. */
	
	DialogObject *DialogPtr;
	
	DialogPtr = CreateDialogObject(EXEC_OBJECT, x, y, width, height,  TheParent);
	
	DialogPtr -> ObjectUnion.AExec.ExecDraw = NULL;
	DialogPtr -> ObjectUnion.AExec.ExecEvent = NULL;
	return(DialogPtr);
	
}

void
ExecFree(DialogObject * TheDialog)
{
	/* Free up and Exec Object */
	
	ExecObject *ExecPtr = &(TheDialog->ObjectUnion.AExec);

	FreeDialogObject(TheDialog);
	
}

void
ExecSetEventFunction(DialogObject *TheDialog, void (*TheEventFunc)(void))
{
	ExecObject *ExecPtr = &(TheDialog->ObjectUnion.AExec);

	ExecPtr->ExecEvent = TheEventFunc;

}

void
ExecSetDrawFunction(DialogObject *TheDialog, void (*TheDrawFunc)(void))
{
	ExecObject *ExecPtr = &(TheDialog->ObjectUnion.AExec);

	ExecPtr->ExecDraw = TheDrawFunc;

}


void
ExecCore(DialogObject *TheDialog)
{
	ExecObject *ExecPtr = &(TheDialog->ObjectUnion.AExec);

	/* Map and draw the exec if required */
	
	if (!TheDialog->IsMapped && ExecPtr->ExecDraw) {
		MapDialog(TheDialog);
		ExecPtr->ExecDraw();
	}

	/* Call the Event function */
	if (ExecPtr->ExecEvent) {
		ExecPtr->ExecEvent();
	}
}