/* 
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * File video.c - Public interface for misc video utilities
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef VIDEO_H
#define VIDEO_H

/* Modes for VideoVgaTricks() */
#define VIDEO_NORMAL		0
#define VIDEO_DOUBLE_SCAN	1
#define VIDEO_STRETCH		2

int VideoInit( void );
void VideoClose( void );
int VideoFindMode(int gfx_width, int gfx_height);
char *VideoGetFramePointer(void);
void VideoFreeFramePointer(void);
int VideoCanMapBuffer(void);
int VideoModeIsLinear(int TheVideoMode);
void VideoSetMode(int TheVideoMode);
void *VideoGetPutLine(int TheVideoMode);
void *VideoGetChangeBank(int TheVideoMode);
void VideoLoadPalette(void);
void VideoDelayedSetPalette(int Color, int Red, int Green, int Blue);
void VideoVgaTricks(int VgaTrickID);

#endif
