
static int BorderY = 0;

void
borderline_update_1x1_copy(void)
{
/* Update either top or bottom borders if required */

   if (ClutChangeInFrame || BorderChangeInFrame) {
	memset(TmpBuff, clut[BORD_VAL(border)], 320);

	PutLine(TmpBuff, BorderY);
   }

   if (BorderY++ == BorderWidth_V_1x1)
   	BorderY = VSize1x1-BorderWidth_V_1x1;
}

void
line_update_vga_mode1_1x1_copy(int LineNo)
{

   unsigned int ink, paper, tmp;
   uns8 attr, i_pix, p_pix;
   uns8* SamAttrPtr;
   int i;

   extern unsigned int y_dtbl[];

/* In Mode 1 we have to update SamMemoryPtr each line due to the 
   spectrum screen layout, but we use a lookup table to minimize
   the cost */

   SamMemoryPtr = realMem[VMPR_SCREEN_PAGE] + y_dtbl[LineNo];
   SamAttrPtr   = realMem[VMPR_SCREEN_PAGE] + 6144+((LineNo & 0xf8)<<2);
   
/* Now we have a long or a short route either we need to update the frame
   buffer (if the memory has been written to, or we have a vmpr/clut change
   to deal with), or we just need to update the read/write pointers */
   
   if (VmprChangeInFrame || ClutChangeInFrame || 
       BorderChangeInFrame || LineNeedsUpdating[LineNo]) {
   /* Long route */   
   
	/* Lhs Border */
	TmpPtr = TmpBuff;
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_1x1);
	TmpPtr += BorderWidth_H_1x1;
	/* The Actual screen line */
	
	for (i=0; i < 32; i++) {
		attr = *SamAttrPtr++;
		ink = Foreground(attr); paper = Background(attr);

		/* toggle the colours if we're in the inverse part of the FLASH cycle */
		if (flash_phase && (attr & 0x80)) {
			tmp=ink; ink=paper; paper=tmp;
		}

		i_pix = clut[ink];
		p_pix = clut[paper];
		*(TmpPtr++) = (*SamMemoryPtr & 0x80) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x40) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x20) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x10) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x08) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x04) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x02) ? i_pix : p_pix;
		*(TmpPtr++) = (*(SamMemoryPtr++) & 0x01) ? i_pix : p_pix;
	}
	
	/* Rhs Border */
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_1x1);
	TmpPtr += BorderWidth_H_1x1;

	LineNeedsUpdating[LineNo] = False;

	PutLine(TmpBuff, LineNo+BorderWidth_V_1x1);

   }
   else {
   /* Short route */
	SamMemoryPtr += 32;             /* 32 Bytes in a mode 2 line */
   }
}

void
line_update_vga_mode2_1x1_copy(int LineNo)
{

   unsigned int ink, paper, tmp;
   uns8 attr, i_pix, p_pix;
   uns8* SamAttrPtr;
   int i;

/* If there is no flagged vmpr change then we only need to update 
   SamMemoryPtr once in a given frame, at LineNo == 0 */
   
   if (VmprChangeInFrame || !LineNo)
	SamMemoryPtr = realMem[VMPR_SCREEN_PAGE] + (LineNo<<5);

/* Now we have a long or a short route either we need to update the frame
   buffer (if the memory has been written to, or we have a vmpr/clut change
   to deal with), or we just need to update the read/write pointers */
   
   if (VmprChangeInFrame || ClutChangeInFrame || 
       BorderChangeInFrame || LineNeedsUpdating[LineNo]) {
   /* Long route */   
   
	/* Lhs Border */
	TmpPtr = TmpBuff;
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_1x1);
	TmpPtr += BorderWidth_H_1x1;

	/* The Actual screen line */
	
	SamAttrPtr = SamMemoryPtr + 0x2000;
	for (i=0; i < 32; i++) {
		attr = *SamAttrPtr++; 
		ink = Foreground(attr); paper = Background(attr);

		/* toggle the colours if we're in the inverse part of the FLASH cycle */
		if (flash_phase && (attr & 0x80)) {
			tmp=ink; ink=paper; paper=tmp;
		}
		i_pix = clut[ink];
		p_pix = clut[paper];
		*(TmpPtr++) = (*SamMemoryPtr & 0x80) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x40) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x20) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x10) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x08) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x04) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x02) ? i_pix : p_pix;
		*(TmpPtr++) = (*(SamMemoryPtr++) & 0x01) ? i_pix : p_pix;
	}
	
	/* Rhs Border */
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_1x1);

	LineNeedsUpdating[LineNo] = False;

	PutLine(TmpBuff, LineNo+BorderWidth_V_1x1);

   }
   else {
   /* Short route */
	SamMemoryPtr += 32;             /* 32 Bytes in a mode 2 line */
   }
}


void
line_update_vga_mode3_1x1_copy(int LineNo)
{
   int i;

/* If there is no flagged vmpr change then we only need to update 
   SamMemoryPtr twice in a given frame, once at LineNo == 0 and once
   at LineNo == 128 (when we cross the page boundry ) */
   
   if (VmprChangeInFrame || !LineNo || (LineNo == 128)) {
	SamMemoryPtr = (LineNo & 0x80) ? 
			realMem[(VMPR_SCREEN_PAGE+1) & 0x1f] + ((LineNo & 0x7f)<<7) :
			realMem[ VMPR_SCREEN_PAGE          ] + (LineNo<<7);
			   
   }

/* Now we have a long or a short route either we need to update the frame
   buffer (if the memory has been written to, or we have a vmpr/clut change
   to deal with), or we just need to update the read/write pointers */
   
   if (VmprChangeInFrame || ClutChangeInFrame || 
       BorderChangeInFrame || LineNeedsUpdating[LineNo]) {
   /* Long route */   
   
	/* Lhs Border */
	TmpPtr = TmpBuff;
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_1x1);
	TmpPtr += BorderWidth_H_1x1;

	/* The Actual screen line */
	
	for (i=0; i < 128; i++) {
		*(TmpPtr++) = clut[HMPR_MD3COL | MD3_SWITCH((*SamMemoryPtr & 0x30) >> 4)];
		*(TmpPtr++) = clut[HMPR_MD3COL | MD3_SWITCH((*SamMemoryPtr & 0x03))];
		SamMemoryPtr++;
	}
	
	/* Rhs Border */
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_1x1);

	LineNeedsUpdating[LineNo] = False;

	PutLine(TmpBuff, LineNo+BorderWidth_V_1x1);

   }
   else {
   /* Short route */
	SamMemoryPtr += 128;            /* 128 Bytes in a mode 3 line */
   }
}

void
line_update_vga_mode4_1x1_copy(int LineNo)
{
   int i;

/* If there is no flagged vmpr change then we only need to update 
   SamMemoryPtr twice in a given frame, once at LineNo == 0 and once
   at LineNo == 128 (when we cross the page boundry ) */
   
   if (VmprChangeInFrame || !LineNo || (LineNo == 128)) {
	SamMemoryPtr = (LineNo & 0x80) ? 
			realMem[(VMPR_SCREEN_PAGE+1) & 0x1f] + ((LineNo & 0x7f)<<7) :
			realMem[ VMPR_SCREEN_PAGE          ] + (LineNo<<7);
			   
   }

/* Now we have a long or a short route either we need to update the frame
   buffer (if the memory has been written to, or we have a vmpr/clut change
   to deal with), or we just need to update the read/write pointers */
   
   if (VmprChangeInFrame || ClutChangeInFrame || 
     BorderChangeInFrame || LineNeedsUpdating[LineNo]) {
   /* Long route */   
   
	/* Lhs Border */
	TmpPtr = TmpBuff;
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_1x1);
	TmpPtr += BorderWidth_H_1x1;

	/* The Actual screen line */
	
	
	for (i=0; i < 128; i++) {
		*(TmpPtr++) = clut[((*SamMemoryPtr)   &0xf0) >> 4];
		*(TmpPtr++) = clut[ (*SamMemoryPtr++) &0x0f];
	}
	
	/* Rhs Border */
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_1x1);

	LineNeedsUpdating[LineNo] = False;

	PutLine(TmpBuff, LineNo+BorderWidth_V_1x1);
   }
   else {
   /* Short route */
	SamMemoryPtr += 128;            /* 128 Bytes in a mode 4 line */
   }
}


void
borderline_update_2x2_copy(void)
{
/* Update either top or bottom borders if required */

   if (ClutChangeInFrame || BorderChangeInFrame) {
	memset(TmpBuff, clut[BORD_VAL(border)], 640);
   
	PutLine(TmpBuff, BorderY);
#ifndef USE_VGA_TRICKS
	PutLine(TmpBuff, BorderY+1);
   }
   BorderY +=2;

   if (BorderY == BorderWidth_V_2x2)
   	BorderY = VSize2x2-BorderWidth_V_2x2;
#else
   }
   BorderY++;

   if (BorderY == BorderWidth_V_2x1)
   	BorderY = VSize2x1-BorderWidth_V_2x1;
#endif

}


void
line_update_vga_mode1_2x2_copy(int LineNo)
{

   unsigned int ink, paper, tmp;
   uns8 attr, i_pix, p_pix;
   uns8* SamAttrPtr;
   int i;

   extern unsigned int y_dtbl[];

/* In Mode 1 we have to update SamMemoryPtr each line due to the 
   spectrum screen layout, but we use a lookup table to minimize
   the cost */

   SamMemoryPtr = realMem[VMPR_SCREEN_PAGE] + y_dtbl[LineNo];
   SamAttrPtr   = realMem[VMPR_SCREEN_PAGE] + 6144+((LineNo & 0xf8)<<2);
   
/* Now we have a long or a short route either we need to update the frame
   buffer (if the memory has been written to, or we have a vmpr/clut change
   to deal with), or we just need to update the read/write pointers */
   
   if (VmprChangeInFrame || ClutChangeInFrame || 
       BorderChangeInFrame || LineNeedsUpdating[LineNo]) {
   /* Long route */   
   
	/* Lhs Border */
	TmpPtr = TmpBuff;
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_2x2);
	TmpPtr += BorderWidth_H_2x2;

	/* The Actual screen line */
	
	for (i=0; i < 32; i++) {
		attr = *SamAttrPtr++;
		ink = Foreground(attr); paper = Background(attr);

		/* toggle the colours if we're in the inverse part of the FLASH cycle */
		if (flash_phase && (attr & 0x80)) {
			tmp=ink; ink=paper; paper=tmp;
		}

		i_pix = clut[ink];
		p_pix = clut[paper];
		*(TmpPtr++) = (*SamMemoryPtr & 0x80) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x80) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x40) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x40) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x20) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x20) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x10) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x10) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x08) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x08) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x04) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x04) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x02) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x02) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x01) ? i_pix : p_pix;
		*(TmpPtr++) = (*(SamMemoryPtr++) & 0x01) ? i_pix : p_pix;
	}
	
	/* Rhs Border */
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_2x2);

	LineNeedsUpdating[LineNo] = False;

#ifndef USE_VGA_TRICKS
	PutLine(TmpBuff,   (LineNo<<1)+BorderWidth_V_2x2);
	PutLine(TmpBuff, 1+(LineNo<<1)+BorderWidth_V_2x2);
#else
	PutLine(TmpBuff,   (LineNo)+BorderWidth_V_2x1);
#endif

   }
   else {
   /* Short route */
	SamMemoryPtr += 32;             /* 32 Bytes in a mode 2 line */

   }
}
void
line_update_vga_mode2_2x2_copy(int LineNo)
{
   unsigned int ink, paper, tmp;
   uns8 attr, i_pix, p_pix;
   uns8* SamAttrPtr;
   int i;

/* If there is no flagged vmpr change then we only need to update 
   SamMemoryPtr once in a given frame, at LineNo == 0 */
   
   if (VmprChangeInFrame || !LineNo)
	SamMemoryPtr = realMem[VMPR_SCREEN_PAGE] + (LineNo<<5);

/* Now we have a long or a short route either we need to update the frame
   buffer (if the memory has been written to, or we have a vmpr/clut change
   to deal with), or we just need to update the read/write pointers */
   
   if (VmprChangeInFrame || ClutChangeInFrame || 
       BorderChangeInFrame || LineNeedsUpdating[LineNo]) {
   /* Long route */   

	/* Lhs Border */
	TmpPtr = TmpBuff;
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_2x2);
	TmpPtr += BorderWidth_H_2x2;

	/* The Actual screen line */
	
	SamAttrPtr = SamMemoryPtr + 0x2000;
	for (i=0; i < 32; i++) {
		attr = *SamAttrPtr++; 
		ink = Foreground(attr); paper = Background(attr);

		/* toggle the colours if we're in the inverse part of the FLASH cycle */
		if (flash_phase && (attr & 0x80)) {
			tmp=ink; ink=paper; paper=tmp;
		}
		i_pix = clut[ink];
		p_pix = clut[paper];
		*(TmpPtr++) = (*SamMemoryPtr & 0x80) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x80) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x40) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x40) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x20) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x20) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x10) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x10) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x08) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x08) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x04) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x04) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x02) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x02) ? i_pix : p_pix;
		*(TmpPtr++) = (*SamMemoryPtr & 0x01) ? i_pix : p_pix;
		*(TmpPtr++) = (*(SamMemoryPtr++) & 0x01) ? i_pix : p_pix;
	}
	
	/* Rhs Border */
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_2x2);

	LineNeedsUpdating[LineNo] = False;

#ifndef USE_VGA_TRICKS
	PutLine(TmpBuff,   (LineNo<<1)+BorderWidth_V_2x2);
	PutLine(TmpBuff, 1+(LineNo<<1)+BorderWidth_V_2x2);
#else
	PutLine(TmpBuff,   (LineNo)+BorderWidth_V_2x1);
#endif

   }
   else {
   /* Short route */
	SamMemoryPtr += 32;             /* 32 Bytes in a mode 2 line */

   }
}
void
line_update_vga_mode3_2x2_copy(int LineNo)
{
   int i;

/* If there is no flagged vmpr change then we only need to update 
   SamMemoryPtr twice in a given frame, once at LineNo == 0 and once
   at LineNo == 128 (when we cross the page boundry ) */
   
   if (VmprChangeInFrame || !LineNo || (LineNo == 128)) {
	SamMemoryPtr = (LineNo & 0x80) ? 
			realMem[(VMPR_SCREEN_PAGE+1) & 0x1f] + ((LineNo & 0x7f)<<7) :
			realMem[ VMPR_SCREEN_PAGE          ] + (LineNo<<7);
			   
   }

/* Now we have a long or a short route either we need to update the frame
   buffer (if the memory has been written to, or we have a vmpr/clut change
   to deal with), or we just need to update the read/write pointers */
   
   if (VmprChangeInFrame || ClutChangeInFrame || 
       BorderChangeInFrame || LineNeedsUpdating[LineNo]) {
   /* Long route */   
   
	/* Lhs Border */
	TmpPtr = TmpBuff;
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_2x2);
	TmpPtr += BorderWidth_H_2x2;

	/* The Actual screen line */
	
	for (i=0; i < 128; i++) {
		*(TmpPtr++) = clut[HMPR_MD3COL | MD3_SWITCH((*SamMemoryPtr & 0xc0) >> 6)];
		*(TmpPtr++) = clut[HMPR_MD3COL | MD3_SWITCH((*SamMemoryPtr & 0x30) >> 4)];
		*(TmpPtr++) = clut[HMPR_MD3COL | MD3_SWITCH((*SamMemoryPtr & 0x0c) >> 2)];
		*(TmpPtr++) = clut[HMPR_MD3COL | MD3_SWITCH((*SamMemoryPtr & 0x03))];
		SamMemoryPtr++;
	}
	
	/* Rhs Border */
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_2x2);

	LineNeedsUpdating[LineNo] = False;

#ifndef USE_VGA_TRICKS
	PutLine(TmpBuff,   (LineNo<<1)+BorderWidth_V_2x2);
	PutLine(TmpBuff, 1+(LineNo<<1)+BorderWidth_V_2x2);
#else
	PutLine(TmpBuff,   (LineNo)+BorderWidth_V_2x1);
#endif

   }
   else {
   /* Short route */
	SamMemoryPtr += 128;            /* 128 Bytes in a mode 3 line */

   }
}

void
line_update_vga_mode4_2x2_copy(int LineNo)
{
   int i;

/* If there is no flagged vmpr change then we only need to update 
   SamMemoryPtr twice in a given frame, once at LineNo == 0 and once
   at LineNo == 128 (when we cross the page boundry ) */
   
   if (VmprChangeInFrame || !LineNo || (LineNo == 128)) {
	SamMemoryPtr = (LineNo & 0x80) ? 
			realMem[(VMPR_SCREEN_PAGE+1) & 0x1f] + ((LineNo & 0x7f)<<7) :
			realMem[ VMPR_SCREEN_PAGE          ] + (LineNo<<7);
			   
   }



/* Now we have a long or a short route either we need to update the frame
   buffer (if the memory has been written to, or we have a vmpr/clut change
   to deal with), or we just need to update the read/write pointers */
   
   if (VmprChangeInFrame || ClutChangeInFrame || 
     BorderChangeInFrame || LineNeedsUpdating[LineNo]) {
   /* Long route */   

	/* If we are using a paged vga mode for 2x2 scaling we need to deal with
	   the switch over lines in a special way */
   
	/* Lhs Border */
	TmpPtr = TmpBuff;
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_2x2);
	TmpPtr += BorderWidth_H_2x2;

	/* The Actual screen line */
	
	for (i=0; i < 128; i++) {
		*(TmpPtr++) = clut[((*SamMemoryPtr)   &0xf0) >> 4];
		*(TmpPtr++) = clut[((*SamMemoryPtr)   &0xf0) >> 4];
		*(TmpPtr++) = clut[ (*SamMemoryPtr)   &0x0f];
		*(TmpPtr++) = clut[ (*SamMemoryPtr++) &0x0f];
	}
	
	/* Rhs Border */
	memset(TmpPtr, clut[BORD_VAL(border)], BorderWidth_H_2x2);

	LineNeedsUpdating[LineNo] = False;

#ifndef USE_VGA_TRICKS
	PutLine(TmpBuff,   (LineNo<<1)+BorderWidth_V_2x2);
	PutLine(TmpBuff, 1+(LineNo<<1)+BorderWidth_V_2x2);
#else
	PutLine(TmpBuff,   (LineNo)+BorderWidth_V_2x1);
#endif

   }
   else {
   /* Short route */
	SamMemoryPtr += 128;            /* 128 Bytes in a mode 4 line */

   }
}

void
FlyBack_copy(void)
{
/* Reset the Border level counter */

    BorderY = 0;
}
